<?php

$list_field=array();
$list_field[]=array("st",x("start time"));
$list_field[]=array("sip",x("source IP address"));
$list_field[]=array("dip",x("destination IP address"));
$list_field[]=array("app",x("application"));
$list_field[]=array("bytes",x("bytes"));
$list_field[]=array("pck",x("packets"));
$list_field[]=array("proto",x("protocol"));
$list_field[]=array("sp",x("source port"));
$list_field[]=array("dp",x("destination port"));
$list_field[]=array("sif",x("source interface"));
$list_field[]=array("dif",x("destination interface"));
$list_field[]=array("sas",x("source AS"));
$list_field[]=array("das",x("destination AS"));
$list_field[]=array("smask",x("source mask"));
$list_field[]=array("dmask",x("destination mask"));
$list_field[]=array("nh",x("nexthop IP address"));
$list_field[]=array("flags",x("TCP flags"));
$list_field[]=array("tos",x("type of service"));
$list_field[]=array("ver",x("netflow version"));
$list_field[]=array("rt",x("device IP address"));

$list_ql[0]=x("source AND destination");
$list_ql[1]=x("source OR destination");
$list_ql[2]=x("source->destination OR destination->source");

$list_iql[0]=x("source AND destination");
$list_iql[1]=x("source OR destination");


$list_limit[20]="20";
$list_limit[25]="25";
$list_limit[50]="50";
$list_limit[100]="100";

$list_type[0]=x("graph and table");
$list_type[1]=x("only graph");
$list_type[2]=x("only table");
 
$list_scale[0]=x("linear");
$list_scale[1]=x("logarithmic");



$list_gtype[10]=x("accumulated filled line");
$list_gtype[20]=x("accumulated filled bar");
$list_gtype[30]=x("accumulated filled spider");
$list_gtype[11]=x("accumulated line");
$list_gtype[21]=x("accumulated bar");
$list_gtype[31]=x("accumulated spider");
$list_gtype[12]=x("accumulated filled line with aprx.");
$list_gtype[13]=x("accumulated line with aprx.");
$list_gtype[14]=x("non-accumulated line");
$list_gtype[32]=x("non-accumulated spider");


$list_igtype[15]=x("filled line");
$list_igtype[22]=x("filled bar");
$list_igtype[14]=x("line");
$list_igtype[23]=x("bar");
$list_igtype[16]=x("filled line with aprx.");
$list_igtype[17]=x("line with aprx.");


function where_add(&$where,$key,$val,$op="=",$lop="OR") {
  if (!$where)
    $where="$key$op$val";
  elseif ($lop)
    $where.=" $lop $key$op$val";
  else
    $where.="$key$op$val";
}



function error_set($err_msg) {
  global $error;
  if (!$error) $error=$err_msg;
}



function trim_arg($string) {
  $string=trim($string);
  while (substr_count($string,"  ") > 0)
    $string=str_replace("  "," ",$string);
  while (substr_count($string,"\t\t") > 0)
    $string=str_replace("\t\t","\t",$string);
  while (substr_count($string," ,") > 0)
    $string=str_replace(" ,",",",$string);
  while (substr_count($string,", ") > 0)
    $string=str_replace(", ",",",$string);
  while (substr_count($string," /") > 0)
    $string=str_replace(" /","/",$string);
  while (substr_count($string,"/ ") > 0)
    $string=str_replace("/ ","/",$string);
  $string=str_replace(" ",",",$string);
  $string=str_replace(";",",",$string);
  $string=str_replace("\t",",",$string);    
  return $string;
}



function parse_ip(&$where,$key,$ip,$not,$lists="") {
  global $error;
  if (trim($ip)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$ip); 
    if (is_array($lists)&&count($lists)) {
      $tmp2=array();
      while (list($ipkey,$ipe)=each($tmp)) {
        $ipe=trim(strtoupper($ipe));
        if ($lists[$ipe]) {
	  unset($tmp[$ipkey]);
	  $tmp2=array_merge($tmp2,explode(",",$lists[$ipe]));
	}
      }
      $tmp=array_merge($tmp,$tmp2);
      reset($tmp);
    }
    foreach ($tmp as $ipe) {
      $ipe=trim($ipe);
      $invertor=0;
      if (preg_match("#^!#",$ipe)) {
	$ipe=substr($ipe,1);
	$invertor=1;
      }
      $ipm=strpos($ipe,"-");
      $ips=strpos($ipe,"/");
      if ($ipm) {
        $ipl=trim(substr($ipe,0,$ipm));
        $iph=trim(substr($ipe,$ipm+1));
	if (!is_ip($ipl))
	  error_set(sprintf(x("Invalid IP address (%s) on the line (%s)"),$ipl,$ip));
	if (!is_ip($iph))
	  error_set(sprintf(x("Invalid IP address (%s) on the line (%s)"),$iph,$ip));
        $ipln=ip2num($ipl);
	$iphn=ip2num($iph);
	if ($ipln > $iphn) {
	  $a = $ipln;
	  $ipln=$iphn;
	  $iphn=$a;
	}
	if ($invertor)
	  where_add($w2,"(".$key,"$ipln AND $iphn)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$ipln AND $iphn)"," BETWEEN ","OR");
      }
      elseif ($ips) {
        $ipi=trim(substr($ipe,0,$ips));
	$net=trim(substr($ipe,$ips+1));
	if (!is_ip($ipi))
	  error_set(sprintf(x("Invalid IP address (%s) on the line (%s)"),$ipi,$ip));
        $ipin=ip2num($ipi);

	/* if / is in mask format x.x.x.x convert to /bitlength */
	if (is_ip($net)) {
	  $a=(double)ip2num($net);
	  $mask=0;
	  for ($i=31;$i>0;$i--) {
	    if (($a>>$i)!=-1)
	      break;
            $mask++;  
	  }
	  if ($mask<2)
	    error_set(sprintf(x("Couldn't convert subnet address (%s) on the line (%s).<br/>".
		"Bitmask length must be greater then 1!"),$net,$ip));
	  $net=$mask;
	}
	 
	if ((!is_numeric($net))||($net<2)||($net > 32))
	    error_set(sprintf(x("Couldn't convert subnet address (%s) on the line (%s).<br/>".
		"Second part must be integer in range 2-32 or netmask."),$net,$ip));
	if (!$error) {
	  $i=(1 << (32-$net));
	  $ipln=floor($ipin/$i) * $i;
	  $iphn=((floor($ipin/$i)+1) * $i)-1;
	}
	
	if ($ipln > $iphn) {
	  $a = $ipln;
	  $ipln=$iphn;
	  $iphn=$a;
	}
	if ($invertor)
	  where_add($w2,"(".$key,"$ipln AND $iphn)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$ipln AND $iphn)"," BETWEEN ","OR");
      }
      else {
	if (!is_ipname($ipe))
	  error_set(sprintf(x("Invalid IP address or hostname (%s) on the line (%s)"),$ipe,$ip));
        $ipl=ip2num($ipe);
	if ($invertor)
          where_add($w2,$key,$ipl,"=","OR");
	else
          where_add($w1,$key,$ipl,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");      
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND");      
  }
}



function parse_proto(&$where,$key,$proto,$not) {
  if (trim($proto)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$proto);
    foreach ($tmp as $protoe) {
      $protoe=trim($protoe);
      $invertor=0;
      if (preg_match("#^!#",$protoe)) {
	$protoe=substr($protoe,1);
	$invertor=1;
      }
      $protom=strpos($protoe,"-");
      if ($protom) {
        $protol=trim(substr($protoe,0,$protom));
	$protoh=trim(substr($protoe,$protom+1));
	if (!is_proto($protol))
	  error_set(sprintf(x("Invalid protocol (%s) on the line (%s)"),$protol,$proto));
	if (!is_proto($protoh))
	  error_set(sprintf(x("Invalid protocol (%s) on the line (%s)"),$protoh,$proto));

        $protoln=proto2num($protol);
	$protohn=proto2num($protoh);
	if ($protoln > $protohn) {
	  $a = $protoln;
	  $protoln=$protohn;
	  $protohn=$a;
	}
	if ($invertor)
	  where_add($w2,"(".$key,"$protoln AND $protohn)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$protoln AND $protohn)"," BETWEEN ","OR");
      }
      else {
	if (!is_proto($protoe))
	  error_set(sprintf(x("Invalid protocol (%s) on the line (%s)"),$protoe,$proto));
        $protoen=proto2num($protoe);
	if ($invertor)
          where_add($w2,$key,$protoen,"=","OR");
	else
          where_add($w1,$key,$protoen,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }
}




function parse_port(&$where,$key,$port,$not) {
  if (trim($port)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$port);    
    foreach ($tmp as $porte) {
      $porte=trim($porte);
      $invertor=0;
      if (preg_match("#^!#",$porte)) {
	$porte=substr($porte,1);
	$invertor=1;
      }
      $portm=strpos($porte,"-");
      if ($portm) {
        $portl=trim(substr($porte,0,$portm));
	$porth=trim(substr($porte,$portm+1));
	if (!is_portdb($portl))
	  error_set(sprintf(x("Invalid port (%s) on the line (%s)"),$portl,$port));
	if (!is_portdb($porth))
	  error_set(sprintf(x("Invalid port (%s) on the line (%s)"),$porth,$port));
        $portln=port2numdb($portl);
	$porthn=port2numdb($porth);
	if ($portln > $porthn) {
	  $a = $portln;
	  $portln=$porthn;
	  $porthn=$a;
	}	  
	if ($invertor)
	  where_add($w2,"(".$key,"$portln AND $porthn)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$portln AND $porthn)"," BETWEEN ","OR");
      }
      else {
	if (!is_portdb($porte))
	  error_set(sprintf(x("Invalid port (%s) on the line (%s)"),$porte,$port));
        $porten=port2numdb($porte);
	if ($invertor)
          where_add($w2,$key,$porten,"=","OR");
	else
          where_add($w1,$key,$porten,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }
}


function parse_app(&$where,$key,$app,$not) {
  if (trim($app)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$app);    
    foreach ($tmp as $appe) {
      $appe=trim($appe);
      $invertor=0;
      if (preg_match("#^!#",$appe)) {
	$appe=substr($appe,1);
	$invertor=1;
      }
      $appm=strpos($appe,"-");
      if ($appm) {
        $appl=trim(substr($appe,0,$appm));
	$apph=trim(substr($appe,$appm+1));
        $applm=strpos($appl,"/");
        $apphm=strpos($apph,"/");

	if ($applm) {
	  $proto=trim(substr($appl,0,$applm));
	  $applp=trim(substr($appl,$applm+1));
	  if (!is_portdb($applp,$proto))
	    error_set(sprintf(x("Invalid port or protocol (%s) on the line (%s)."),$appl,$app));
	  if ($proto=="tcp")
	    $appln=port2numdb($applp,6);
	  elseif ($proto=="udp")
	    $appln=port2numdb($applp,17)+100000;
	  elseif ($proto=="icmp")
	    $appln=port2numdb($applp,1)+200000;	 	  
	  else
	    error_set(sprintf(x("Not supported protocol (%s) on the line (%s)."),$proto,$app));
	}
	elseif (is_numeric($appl))
          $appln=$appl;
	elseif (is_proto($appl))
	  $appln=proto2num($appl)+90000;
	else
          $appln=load_appid($appl)+300000;	

	if ($apphm) {
	  $proto=trim(substr($apph,0,$apphm));
	  $apphp=trim(substr($apph,$apphm+1));
	  if (!is_portdb($apphp,$proto))
	    error_set(sprintf(x("Invalid port or protocol (%s) on the line (%s)."),$apph,$app));
	  if ($proto=="tcp")
	    $apphn=port2numdb($apphp,6);
	  elseif ($proto=="udp")
	    $apphn=port2numdb($apphp,17)+100000;
	  elseif ($proto=="icmp")
	    $apphn=port2numdb($apphp,1)+200000;	 	  
	  else
	    error_set(sprintf(x("Not supported protocol (%s) on the line (%s)."),$proto,$app));
	}
	elseif (is_numeric($apph))
          $apphn=$apph;
	elseif (is_proto($apph))
	  $apphn=proto2num($apph)+90000;
	else
          $apphn=load_appid($apph)+300000;	

	if ($appln==300000)
	  error_set(sprintf(x("Invalid application (%s) on the line (%s)"),$appl,$app));
	if ($apphn==300000)
	  error_set(sprintf(x("Invalid application (%s) on the line (%s)"),$apph,$app));

	if ($appln > $apphn) {
	  $a = $appln;
	  $appln=$apphn;
	  $apphn=$a;
	}	  
	if ($invertor)
	  where_add($w2,"(".$key,"$appln AND $apphn)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$appln AND $apphn)"," BETWEEN ","OR");
      }
      else {
        $appem=strpos($appe,"/");
	if ($appem) {
	  $proto=trim(substr($appe,0,$appem));
	  $appep=trim(substr($appe,$appem+1));

	  if (!is_portdb($appep,$proto))
	    error_set(sprintf(x("Invalid port or protocol (%s) on the line (%s)."),$appe,$app));
	  if ($proto=="tcp")
	    $appen=port2numdb($appep,6);
	  elseif ($proto=="udp")
	    $appen=port2numdb($appep,17)+100000;
	  elseif ($proto=="icmp")
	    $appen=port2numdb($appep,1)+200000;	 	  
	  else
	    error_set(sprintf(x("Not supported protocol (%s) on the line (%s)."),$proto,$app));
	}
	elseif (is_numeric($appe))
          $appen=$appe;
	elseif (is_proto($appe))
	  $appen=proto2num($appe)+90000;
	else
          $appen=load_appid($appe)+300000;	
	  
	if ($appen==300000)
	  error_set(sprintf(x("Invalid application (%s) on the line (%s)"),$appe,$app));
	if ($invertor)
          where_add($w2,$key,$appen,"=","OR");
	else
          where_add($w1,$key,$appen,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }  
}


function parse_num(&$where,$key,$vals,$not,$min="",$max="") {
  if (trim($vals)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$vals);
    foreach ($tmp as $val) {
      $val=trim($val);
      $invertor=0;
      if (preg_match("#^!#",$val)) {
	$val=substr($val,1);
	$invertor=1;
      }
      $valm=strpos($val,"-");
      if ($valm) {
        $vall=trim(substr($val,0,$valm));
	$valh=trim(substr($val,$valm+1));
	if (!is_numeric($vall))
	  error_set(sprintf(x("Invalid number (%s) on the line (%s)."),$vall,$vals));
	if (!is_numeric($valh))
	  error_set(sprintf(x("Invalid number (%s) on the line (%s)."),$valh,$vals));
	if ($vall > $valh) {
	  $a = $vall;
	  $vall=$valh;
	  $valh=$a;
	}	  
	if ($max!="") {
	  if ($vall>$max)
	    error_set(sprintf(x("Invalid number (%s) on the line (%s). The number must be less or equal '%s'."),$vall,$vals,$max));
	  if ($valh>$max)
	    error_set(sprintf(x("Invalid number (%s) on the line (%s). The number must be less or equal '%s'."),$valh,$vals,$max));
	}
	if ($min!="") {
	  if ($vall<$min)
	    error_set(sprintf(x("Invalid number (%s) on the line (%s). The number must be greater or equal '%s'."),$vall,$vals,$min));
	  if ($valh<$min)
	    error_set(sprintf(x("Invalid number (%s) on the line (%s). The number must be greater or equal '%s'."),$valh,$vals,$min));
	}
	if ($invertor)
	  where_add($w2,"(".$key,"$vall AND $valh)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$vall AND $valh)"," BETWEEN ","OR");
      }
      else {
	if (!is_numeric($val))
	  error_set(sprintf(x("Invalid number (%s) on the line (%s)."),$val,$vals));
	if ($max!="") {
	  if ($val>$max)
	    error_set(sprintf(x("Invalid number (%s) on the line (%s). The number must be less or equal '%s'."),$val,$vals,$max));
	}
	if ($min!="") {
	  if ($val<$min)
	    error_set(sprintf(x("Invalid number (%s) on the line (%s). The number must be greater or equal '%s'."),$val,$vals,$min));
	}
	if ($invertor)
          where_add($w2,$key,$val,"=","OR");
	else
          where_add($w1,$key,$val,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }
}


function parse_time(&$where,$key,$vals,$not,$refer="") {
  if (trim($vals)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$vals);
    foreach ($tmp as $val) {
      $val=trim($val);
      $invertor=0;
      if (preg_match("#^!#",$val)) {
	$val=substr($val,1);
	$invertor=1;
      }
      $valm=strpos($val,"-");
      if ($valm) {
	$vall=trim(substr($val,0,$valm));
	$valh=trim(substr($val,$valm+1));
        $valtl=strtotime($vall,$refer);
	$valth=strtotime($valh,$refer);
	if ($valtl<1)
	  error_set(sprintf(x("Invalid time value (%s) on the line (%s)."),$vall,$vals));
	if ($valth<1)
	  error_set(sprintf(x("Invalid time value (%s) on the line (%s)."),$valh,$vals));
	if ($refer && $valtl<$refer)
	  error_set(sprintf(x("Invalid time value (%s) on the line (%s)<br/>Value out of range."),$vall,$vals));
	if ($refer && $valth<$refer)
	  error_set(sprintf(x("Invalid time value (%s) on the line (%s)<br/>Value out of range."),$valh,$vals));
	if ($valtl > $valth) {
	  $a = $valtl;
	  $valtl=$valth;
	  $valth=$a;
	}
	if ($invertor)
	  where_add($w2,"(".$key,"$valtl AND $valth)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$valtl AND $valth)"," BETWEEN ","OR");
      }
      else {
	$valt=strtotime($val,$refer);
	if ($valt<1)
	  error_set(sprintf(x("Invalid time value (%s) on the line (%s)."),$val,$vals));
	if ($refer && $valt<$refer)
	  error_set(sprintf(x("Invalid time value (%s) on the line (%s)<br/>Value out of range."),$val,$vals));
	if ($invertor)
          where_add($w2,$key,$valt,"=","OR");
	else
          where_add($w1,$key,$valt,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }
}


function parse_flags(&$where,$key,$vals) {
  if (trim($vals)!=="") {
    $vals=str_replace(" ",",",$vals);
    $tmp=explode(",",$vals);
    if (count($tmp)>2)
      error_set(sprintf(x("Too many parameters (%d) for TCP flags (%s).",count($tmp),$vals)));
    $f1=trim(strtoupper($tmp[0]));
    $f2=trim(strtoupper($tmp[1]));
    if ($f2=="") {
      if (!strstr($f1,'*'))
	$f2=$f1;
      else {
	$f2="*";
	$f1="";
      }	
    }
    if (strstr($f1,'*'))
      $f1='12UAPRSF';
    if (strstr($f2,'*'))
      $f2='12UAPRSF';
    if (!preg_match('#[12UAPRSF]+#',$f1)||!preg_match('#[12UAPRSF]+#',$f2))
      error_set(sprintf(x("Unknown TCP flag character (%s). Allowed chars are [12UAPRSF].",$vals)));
    $fl_ok=0;
    $fl_bad=0;
    if (strstr($f2,'1')) {
      if (strstr($f1,'1')) $fl_ok+=128; else $fl_bad+=128;
    }
    if (strstr($f2,'2')) {
      if (strstr($f1,'2')) $fl_ok+=64; else $fl_bad+=64;
    }
    if (strstr($f2,'U')) {
      if (strstr($f1,'U')) $fl_ok+=32; else $fl_bad+=32;
    }
    if (strstr($f2,'A')) {
      if (strstr($f1,'A')) $fl_ok+=16; else $fl_bad+=16;
    }
    if (strstr($f2,'P')) {
      if (strstr($f1,'P')) $fl_ok+=8; else $fl_bad+=8;
    }
    if (strstr($f2,'R')) {
      if (strstr($f1,'R')) $fl_ok+=4; else $fl_bad+=4;
    }
    if (strstr($f2,'S')) {
      if (strstr($f1,'S')) $fl_ok+=2; else $fl_bad+=2;
    }
    if (strstr($f2,'F')) {
      if (strstr($f1,'F')) $fl_ok+=1; else $fl_bad+=1;
    }
    if ($fl_ok)
      where_add($where,'('.$key,$fl_ok.'='.$fl_ok.')','&',"AND");
    if ($fl_bad)
      where_add($where,'('.$key,$fl_bad.'=0)','&',"AND");
  }
}



function parse_tos(&$where,$key,$tos,$not) {
  if (trim($tos)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$tos);    
    foreach ($tmp as $tose) {
      $tose=trim($tose);
      $invertor=0;
      if (preg_match("#^!#",$tose)) {
	$tose=substr($tose,1);
	$invertor=1;
      }
      $tosm=strpos($tose,"-");
      if ($tosm) {
        $tosl=trim(substr($tose,0,$tosm));
	$tosh=trim(substr($tose,$tosm+1));
        $tosln=tos2num($tosl);
	$toshn=tos2num($tosh);
	if ($tosln===false)
	  error_set(sprintf(x("Invalid type of service (%s) on the line (%s)"),$tosl,$tos));
	if ($toshn===false)
	  error_set(sprintf(x("Invalid type of service (%s) on the line (%s)"),$tosh,$tos));
	if ($tosln > $toshn) {
	  $a = $tosln;
	  $tosln=$toshn;
	  $toshn=$a;
	}	  
	if ($invertor)
	  where_add($w2,"(".$key,"$tosln AND $toshn)"," BETWEEN ","OR");
	else
	  where_add($w1,"(".$key,"$tosln AND $toshn)"," BETWEEN ","OR");
      }
      else {
	$tosen=tos2num($tose);
	if ($tosen===false)
	  error_set(sprintf(x("Invalid type of service (%s) on the line (%s)"),$tose,$tos));
	if ($invertor)
          where_add($w2,$key,$tosen,"=","OR");
	else
          where_add($w1,$key,$tosen,"=","OR");
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }
}



function parse_iface(&$where,$key,$vals,$not) {
  global $fields;
  $min=0;
  $max=65535;
  if (trim($vals)!=="") {
    if ($not) $not=" NOT"; else $not="";
    $w1="";
    $w2="";
    $tmp=explode(",",$vals);
    foreach ($tmp as $val) {
      $val=trim($val);
      $invertor=0;
      if (preg_match("#^!#",$val)) {
	$val=substr($val,1);
	$invertor=1;
      }
      $rt="";
      if (preg_match("#@#",$val)) {
	list($rt,$val)=explode("@",$val);
	if (!is_ipname($rt))
	  error_set(sprintf(x("Invalid export device address (%s) on the line (%s)."),$rt,$vals));
        $rt=ip2num($rt);
      }
      $valm=strpos($val,"-");
      if ($valm) {
        $vall=trim(substr($val,0,$valm));
	$valh=trim(substr($val,$valm+1));
	if (!is_numeric($vall) || $vall<$min || $vall>$max)
	  error_set(sprintf(x("Invalid interface index (%s) on the line (%s). Numbers in this field can only be in the range of %d-%d."),$vall,$vals,$min,$max));
	if (!is_numeric($valh) || $valh<$min || $valh>$max)
	  error_set(sprintf(x("Invalid interface index (%s) on the line (%s). Numbers in this field can only be in the range of %d-%d."),$valh,$vals,$min,$max));
	if ($vall > $valh) {
	  $a = $vall;
	  $vall=$valh;
	  $valh=$a;
	}

	if ($rt && strstr($fields,"rt")) {
	  if ($invertor)
	    where_add($w2,"(rt='$rt' AND ".$key,"$vall AND $valh)"," BETWEEN ","OR");
	  else
	    where_add($w1,"(rt='$rt' AND ".$key,"$vall AND $valh)"," BETWEEN ","OR");
	}
	else {
	  if ($invertor)
	    where_add($w2,"(".$key,"$vall AND $valh)"," BETWEEN ","OR");
	  else
	    where_add($w1,"(".$key,"$vall AND $valh)"," BETWEEN ","OR");
	}
      }
      else {
	if (!is_numeric($val) || $val<$min || $val>$max)
	  error_set(sprintf(x("Invalid interface index (%s) on the line (%s). Numbers in this field can only be in the range of %d-%d."),$val,$vals,$min,$max));

	if ($rt && strstr($fields,"rt")) {
	  if ($invertor)
            where_add($w2,"(rt='$rt' AND ".$key,$val.")","=","OR");
	  else
            where_add($w1,"(rt='$rt' AND ".$key,$val.")","=","OR");
	}
	else {
	  if ($invertor)
            where_add($w2,$key,$val,"=","OR");
	  else
            where_add($w1,$key,$val,"=","OR");
	}
      }
    }
    if ($w1 && $w2)
      where_add($where,"",$not."(($w1)AND NOT($w2))","","AND");      
    elseif ($w1)
      where_add($where,"",$not."($w1)","","AND");
    elseif ($w2)
      where_add($where,"",$not."(NOT ($w2))","","AND"); 
  }
}


function graph_create($caption,$subcaption,$type,$scale,$axisx="",$axisy="",$comment="",$scaletype="",$capacity="") {
  global $u_id;
  
  $t=time();
  $id=md5($u_id.uniqid(rand(),true).$t);
  $v=SQL_escape(array($caption,$subcaption,$type,$scale,$axisx,$axisy,$comment,$scaletype,$capacity));
  if (SQL_query("INSERT INTO x_graph (id,id_user,caption,subcaption,scale,type,axisx,axisy,flag,comment,created,scaletype,capa) 
		VALUES('$id','$u_id','$v[0]','$v[1]','$v[3]','$v[2]','$v[4]','$v[5]','cache','$v[6]','$t','$v[7]','$v[8]')"))
    return $id;
  return "";
}


function graph_addval(&$line,$value) {
  if ($line)
    $line.=",$value";
  else
    $line=" $value";
}


function graph_insert($id_graph,$axis,$value,$legend="") {
  SQL_query("INSERT INTO x_graphd (id_graph,axis,value,legend) VALUES('$id_graph','$axis','$value','$legend')");
}


function FItem($field,$name,$input) {
  global $fields;
  $negname="n".$field;
  global $$negname;
  
  $neg[0]=""; $neg[1]=x("not");
  if (strstr($fields,$field)) {
    TNext();
    TItem($name);
    TItem(InputSelect($negname,select_list($neg,$$negname)).$input);
  }
}


function FVItem($field,$name) {
  global $fields;
  $vval='v'.$field;
  global $$vval;
  getGlobalVar($vval,$$vval);
  
  if (strstr($fields,$field)) {
    TNext();
    TItem(InputCheck($vval,'1',i_chk($$vval)).$name);
  }
}

function FOItem($field,$name) {
  global $fields;
  $vval='o'.$field;
  global $$vval;
  getGlobalVar($vval,$$vval);
  
  if (strstr($fields,$field)) {
    TNext();
    TItem(InputCheck($vval,'1',i_chk($$vval)).$name);
  }
}



function load_appid($name) {
  $ret=0;
  $res=SQL_query("SELECT id from x_app WHERE short like '".SQL_escape($name)."'");
  if ($res) {
    if ($row=SQL_fetch_array($res))
      $ret=$row[0];
    SQL_free_result($res);
  }
  return $ret;
}

function load_typetable($id,$type) {
  $ret=array();
  $res=SQL_query("SELECT name,flag,st,et FROM x_table WHERE name like '$type$id\\_%%' AND flag!='B' ORDER BY flag DESC, name DESC");
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      $n=preg_replace("#.[0-9]+_#","",$row[0]);
      switch ($type) {
        case 'h':
	  $ret[$row[0]]=x("hourly table")." - ".strftime('%Y/%m/%d %H:%M',$row[2])."-".strftime('%H:%M',$row[3]+1); break;
        case 'd':
	  $ret[$row[0]]=x("daily table")." - ".strftime('%Y/%m/%d %H:%M',$row[2]); break;
        case 'w':
	  $ret[$row[0]]=x("weekly table")." - ".strftime('%Y/%m/%d %H:%M',$row[2]); break;
        case 'm':
	  $ret[$row[0]]=x("monthly table")." - ".strftime('%Y/%m/%d %H:%M',$row[2]); break;
        case 'o':
	  $ret[$row[0]]='*'.x("hourly table")." - ".strftime('%Y/%m/%d %H:%M',$row[2])."-".strftime('%H:%M',$row[3]+1); break;
        case 'p':
	  $ret[$row[0]]='*'.x("daily table")." - ".strftime('%Y/%m/%d %H:%M',$row[2]); break;
        case 'q':
	  $ret[$row[0]]='*'.x("weekly table")." - ".strftime('%Y/%m/%d %H:%M',$row[2]); break;
        case 'r':
	  $ret[$row[0]]='*'.x("monthly table")." - ".strftime('%Y/%m/%d %H:%M',$row[2]); break;	  
      }
    }
    SQL_free_result($res);
  }
  return $ret;
}


function load_tables($id,$type="") {
  if ($type)
    return load_typetable($id,$type);
  $h=load_typetable($id,"h");
  $d=load_typetable($id,"d");
  $w=load_typetable($id,"w");
  $m=load_typetable($id,"m");
  $o=load_typetable($id,"o");
  $p=load_typetable($id,"p");
  $q=load_typetable($id,"q");
  $r=load_typetable($id,"r");
  $ret=$h+$d+$w+$m+$o+$p+$q+$r;  
  return $ret;
}


function load_network($id) {
  $ret="";
  $res=SQL_query("SELECT ip FROM x_network WHERE id='".SQL_escape($id)."'");
  if ($res) {
    if ($row=SQL_fetch_array($res))
      $ret=$row[0];
    SQL_free_result($res);
  }
  return $ret;
}


function load_networks() {
  $ret=array();
  $res=SQL_query("SELECT name,ip FROM x_network");
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $ret[trim(strtoupper($row[0]))]=$row[1];
    SQL_free_result($res);
  }
  return $ret;  
}


function get_table_start($table) {
  $ret="";
  
  $res=SQL_query("SELECT st FROM x_table WHERE name='".SQL_escape($table)."'");
  if ($res) {
    if ($row=SQL_fetch_row($res))
      $ret=$row[0];
    SQL_free_result($res);
  }
  return $ret;
}

function get_table_info($table,&$id_db,&$fields,&$min,&$max,&$agg_c,&$agg_w,&$flag,&$type,&$collector,&$time,&$name,&$step) {
  $ret=0;
  
  $res=SQL_query("SELECT id_db,field,flag,agg_c,agg_w,st,et FROM x_table WHERE name='".SQL_escape($table)."'");
  if ($res) {
    if ($row=SQL_fetch_row($res)) {
      $id_db=$row[0];
      if ($row[1])
        $fields=$row[1];
      $min=$row[5];
      $max=$row[6];
      $agg_c=$row[3];
      $agg_w=$row[4];
      $flag=$row[2];
      if (preg_match("#(.)([[:digit:]]+)\_(.*)#i",$table,$reg)) {
	$type=$reg[1];
	$collector=$reg[2];
	$time=$reg[3];
	switch ($type) {
	  case 'o': $type='h'; break;
	  case 'p': $type='d'; break;
	  case 'q': $type='w'; break;
	  case 'r': $type='m'; break;
	}
        if ($type=='h')
	  $res2=SQL_query("SELECT name FROM x_coll WHERE id=".SQL_escape($collector)); 
        else
	  $res2=SQL_query("SELECT name,s$type FROM x_coll WHERE id=".SQL_escape($collector)); 
        if ($res2) {
	  if ($row2=SQL_fetch_row($res2)) {
            $name=$row2[0];
    	    $step=(isset($row2[1])) ? $row2[1] : '';
    	    $ret=1;
	  } 
	  SQL_free_result($res2);
	}
      }
    }
    SQL_free_result($res);
  }
  switch ($type) {
    case 'h': $step=60; break;
    case 'd': if (!$step) $step=3600; break;
    case 'w': if (!$step) $step=86400; break;
    case 'm': if (!$step) $step=86400; break;
  }
  
  if (!$ret)
    error_set(x("Error when analyzing table..."));
  return $ret;
}


function email_form()  {
  global $em_to,$em_subj,$em_text;
  demo_die();
  FormStart();
  popup_script("450","500");

  $arga=explode("&",args(array(search=>0,em_to=>'',em_subj=>'',em_text=>'')));
  foreach ($arga as $arg) {
    $keys=explode("=",$arg);
    if ($keys[0]&&$keys[1])
      echo InputHidden($keys[0],$keys[1]);
  }
  echo InputHidden("search","email2");
  WinStart(x("Send results to email"));
  TItem(x("To:"));
  TItem(Input("em_to",$em_to,255).show_history("email","em_to"));
  TNext();
  TItem(x("Subject:"));
  TItem(Input("em_subj",$em_subj,32).show_history("email_subj","em_subj"));
  TNext();
  TItem(x("Text:"));
  TItem(InputText("em_text",$em_text));
  TNext();
  TItem("<br>".InputSubmit("email",x("Email")),'COLSPAN="2" ALIGN="center"');
  WinEnd();
  FormEnd();
}


function export_form()  {
  demo_die();
  FormStart();
  $arga=explode("&",args("search=0"));
  foreach ($arga as $arg) {
    $keys=explode("=",$arg);
    if ($keys[0]&&$keys[1])
      echo InputHidden($keys[0],$keys[1]);
  }
  echo InputHidden("search","export2");
  WinStart(x("Exporting parameters"));
  TItem(x("Filename:"));
  TItem(Input("efil",strftime("%y%m%d-%H%M%S",time()),16));
  TNext();
  TItem(x("Maximum of exported lines:"));
  TItem(Input("enum",$enum,10));
  TNext();
  TItem(x("Time format:"));
  TItem(Input("etfm","",24));
  TNext();
  TItem(InputCheck("ehdr",'1',i_chk($ehdr)).x("include fields header"),'COLSPAN="2"');
  TNext();
  TItem("<br>".InputSubmit("export",x("Export")),'COLSPAN="2" ALIGN="center"');
  WinEnd();
  FormEnd();
  
  echo "<BR><BR>\n";
  
  WinStart(x("Time formats"));
  TItem("%y");
  TItem(x("year as a decimal number without a century (range 00 to 99)"));
  TNext();
  TItem("%m");
  TItem(x("month as a decimal number (range 01 to 12)"));
  TNext();
  TItem("%d");
  TItem(x("day of the month as a decimal number (range 01 to 31)"));
  TNext();
  TItem("%H");
  TItem(x("hour as a decimal number when using a 24-hour clock (range 00 to 23)"));
  TNext();
  TItem("%M");
  TItem(x("minute as a decimal number"));
  TNext();
  TItem("%S");
  TItem(x("second as a decimal number"));
  TNext();
  TItem("%Y");
  TItem(x("year as a decimal number including the century"));
  TNext();
  TItem("%x");
  TItem(x("preferred date representation for the current locale without the time"));
  TNext();
  TItem("%X");
  TItem(x("preferred time representation for the current locale without the date"));
  WinEnd();
  echo "<br><br>\n";  
  echo x("For complete list of time formats, please, see PHP documentation")." ";
  echo ShowLink(x("(PHP online)"),"http://www.php.net/manual/en/function.strftime.php");
}

function export_name($exportname="search") {
  global $u_id,$efil;

  /* accept only alnum,space,- chars */
  $efil=trim(preg_replace("#[^[:alnum:] -]#", "", $efil)); 
  if (!$efil)
    $efil=strftime("%y%m%d-%H%M%S",time());
  return PRG_EXPORTDIR."export".$exportname."_".$u_id."_".$efil.".csv";
}


function export_open($name) {
  global $export_handle;

  $export_handle=@fopen($name,"w");
  return $export_handle;
}



function export_close() {
  global $export_handle;

  if ($export_handle)
    fclose($export_handle);
  $export_handle=0;
}


function count_capacity($capa,$step="60",$bps="") {
  if (preg_match("#([0-9]+)([kmg])#i", trim($capa), $regs)) {
    switch ($regs[2]) {
      case 'k':
      case 'K': $capa=$regs[1]*1000; break;
      case 'm':
      case 'M': $capa=$regs[1]*1000000; break;
      case 'g':
      case 'G': $capa=$regs[1]*1000000000; break;
      default: $capa=$regs[1];
    }
  }
  if (!is_numeric($capa))
    return '';
  if ($bps)
    return $capa;
  return floor($capa*($step/8)); /* convert speed in bit/sec to bytes per step avr 8bit = 1B */
}



function trends_stat_list($fields) {
  $return=array();
  $return["bytes"]=x("Bytes");
  $return["pck"]=x("Packets");
  $return["pdis"]=x("Packets distribution");
  $return["flows"]=x("Flows");


  if (strstr($fields,"sip")) {
    $return["sipb"]=x("Top source hosts per byte");
    $return["sipp"]=x("Top source hosts per packet");
  }
  if (strstr($fields,"sip")&&strstr($fields,"dip"))
    $return["sdis"]=x("Top source hosts distribution");


  if (strstr($fields,"dip")) {
    $return["dipb"]=x("Top destination hosts per byte");
    $return["dipp"]=x("Top destination hosts per packet");
  }
  if (strstr($fields,"sip")&&strstr($fields,"dip"))
    $return["ddis"]=x("Top destination hosts distribution");

  if (strstr($fields,"sip")&&strstr($fields,"dip")) {
    $return["conb"]=x("Top hosts conversations per byte");
    $return["conp"]=x("Top hosts conversations per packet");
  }


  if (strstr($fields,"app")) {
    $return["appb"]=x("Top applications per byte");
    $return["appp"]=x("Top applications per packet");
  }

  if (strstr($fields,"proto")) {
    $return["protob"]=x("Top protocols per byte");
    $return["protop"]=x("Top protocols per packet");
  }

  if (strstr($fields,"tos")) {
    $return["tosb"]=x("Top ToS/DSCP per byte");
    $return["tosp"]=x("Top ToS/DSCP per packet");  
  }


  if (strstr($fields,"sp")) {
    $return["spb"]=x("Top source TCP/UDP ports per byte");
    $return["spp"]=x("Top source TCP/UDP ports per packet");
  }
  if (strstr($fields,"dp")) {
    $return["dpb"]=x("Top destination TCP/UDP ports per byte");
    $return["dpp"]=x("Top destination TCP/UDP ports per packet");
  }


  if (strstr($fields,"sif")) {
    $return["sifb"]=x("Top source interfaces per byte");
    $return["sifp"]=x("Top source interfaces per packet");
  }
  if (strstr($fields,"dif")) {
    $return["difb"]=x("Top destination interfaces per byte");
    $return["difp"]=x("Top destination interfaces per packet");
  }  
  if (strstr($fields,"sif")&&strstr($fields,"dif")) {
    $return["cifb"]=x("Top interfaces conversations per byte");
    $return["cifp"]=x("Top interfaces conversations per packet");
  }

  if (strstr($fields,"sas")) {
    $return["sasb"]=x("Top source ASes per byte");
    $return["sasp"]=x("Top source ASes per packet");
  }
  if (strstr($fields,"das")) {
    $return["dasb"]=x("Top destination ASes per byte");
    $return["dasp"]=x("Top destination ASes per packet");  
  }
  if (strstr($fields,"sas")&&strstr($fields,"das")) {
    $return["casb"]=x("Top AS conversations per byte");
    $return["casp"]=x("Top AS conversations per packet");  
  }

  if (strstr($fields,"nh")) {
    $return["nhb"]=x("Top next hops per byte");
    $return["nhp"]=x("Top next hops per packet");  
  }

  if (strstr($fields,"proto") && strstr($fields,"dp")) {
    $return["icmpb"]=x("Top ICMP messages per byte");
    $return["icmpp"]=x("Top ICMP messages per packet");
  }
  return $return;
}

function legend($type,$item) {
  global $drn,$stat,$dsif;
  switch ($stat) {
    case "bytes":
      if ($type==RESULT_GRAPH) return "";    
      return x("Bytes");

    case "pck":
      if ($type==RESULT_GRAPH) return "";    
      return x("Packets");

    case "pdis":
      return ($item[0]."-".($item[0]+200))."B";

    case "flows":
      if ($type==RESULT_GRAPH) return "";    
      return x("Flows");

    case "sipb":
    case "sipp":
    case "sdis":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_ip($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("sip=".num2ip($item[0])));
      return xformat_ip($type,$item[0]);

    case "dipb":
    case "dipp":
    case "ddis":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_ip($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("dip=".num2ip($item[0])));
      return xformat_ip($type,$item[0]);

    case "conb":
    case "conp":
      if ($type==RESULT_GRAPH) {
	$drn_b=$drn;
	$drn=1;
	$ret=xformat_ip($type,$item[0])."\n".xformat_ip($type,$item[1]);
	$drn=$drn_b;
	return $ret; 
      }
      if ($type==RESULT_HTML)
        return ShowLink(xformat_ip($type,$item[0])."<br/>".xformat_ip($type,$item[1]),
		PRG_PATH."src/data/trends_a.php?".args(array("sip"=>num2ip($item[0]),"dip"=>num2ip($item[1]))));
      return xformat_ip($type,$item[0])." ".xformat_ip($type,$item[1]);

    case "appb":
    case "appp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_app($type,$item[0],$item[1]),PRG_PATH."src/data/trends_a.php?".args("app=".$item[0]));
      return xformat_app($type,$item[0],$item[1]);


    case "protob":
    case "protop":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_proto($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("proto=".$item[0]));
      return xformat_proto($type,$item[0]);


    case "tosb":
    case "tosp": 
      if ($type==RESULT_HTML)
        return ShowLink(xformat_tos($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("tos=".$item[0]));
      return xformat_tos($type,$item[0]);


    case "spb":
    case "spp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_port($type,$item[0],$item[1]),PRG_PATH."src/data/trends_a.php?".args("sp=".$item[0]));
      return xformat_port($type,$item[0],$item[1]);

    case "dpb":
    case "dpp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_port($type,$item[0],$item[1]),PRG_PATH."src/data/trends_a.php?".args("dp=".$item[0]));
      return xformat_port($type,$item[0],$item[1]);


    case "sifb":
    case "sifp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_interface($type,$item[0],$item[1]),PRG_PATH."src/data/trends_a.php?".args("sif=".$item[0]));
      return xformat_interface($type,$item[0],$item[1]);

    case "difb":
    case "difp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_interface($type,$item[0],$item[1]),PRG_PATH."src/data/trends_a.php?".args("dif=".$item[0]));
      return xformat_interface($type,$item[0],$item[1]);

    case "cifb":
    case "cifp":
      $dsif=1;
      if ($type==RESULT_GRAPH)
	return xformat_interface($type,$item[0],$item[2])."\n".xformat_interface($type,$item[1],$item[2]);
      if ($type==RESULT_HTML)
        return ShowLink(xformat_interface($type,$item[0],$item[2])."<br/>".xformat_interface($type,$item[1],$item[2]),
		PRG_PATH."src/data/trends_a.php?".args(array("sif"=>$item[0],"dif"=>$item[1])));

    case "sasb":
    case "sasp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_as($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("sas=".$item[0]));
      return xformat_as($type,$item[0]);

    case "dasb":
    case "dasp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_as($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("das=".$item[0]));
      return xformat_as($type,$item[0]);

    case "casb":
    case "casp":
      if ($type==RESULT_GRAPH) {
	$drn_b=$drn;
	$drn=1;
	$ret=xformat_as($type,$item[0])."\n".xformat_as($type,$item[1]);
	$drn=$drn_b;
	return $ret; 
      }
      if ($type==RESULT_HTML)
        return ShowLink(xformat_as($type,$item[0])."<br/>".xformat_as($type,$item[1]),
		PRG_PATH."src/data/trends_a.php?".args(array("sas"=>$item[0],"das"=>$item[1])));
      return xformat_as($type,$item[0])." ".xformat_as($type,$item[1]);

    case "nhb":
    case "nhp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_ip($type,$item[0]),PRG_PATH."src/data/trends_a.php?".args("nh=".$item[0]));
      return xformat_ip($type,$item[0]);

    case "icmpb":
    case "icmpp":
      if ($type==RESULT_HTML)
        return ShowLink(xformat_port($type,$item[0],1),PRG_PATH."src/data/trends_a.php?".args(array("proto"=>1,"dp"=>$item[0])));
      return xformat_port($type,$item[0],1);

    default:
      return ($item[0]);
  }

}



function trends_query($stat,&$caption,&$wquery,&$pquery,&$tquery,&$query,&$axisy,&$bps) {
  global $where,$fields,$name,$table,$xtable,$offset;

  if (!is_numeric($offset)||$offset<1) 
    $offset=0;
  $offset=floor($offset/10)*10;
  
  switch ($stat) {
    default:
    case "bytes":
        $caption=x("Bytes statistics for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,bytes FROM $table WHERE $where";
	$pquery="";
	$tquery="";
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";
	$axisy=x("Bytes");
	break;
    case "pck":
        $caption=x("Packets statistics for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,pck FROM $table WHERE $where";
	$pquery="";    
	$tquery="";
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";    
	$axisy=x("Packets");
	break;
    case "pdis":
	if (!$where) {
	  $where="1";
	  trends_maketemp();
	}
        $caption=x("Packets distribution for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,(floor((bytes/pck)/200)*200)as pd,sum(pck)as pck FROM $table WHERE $where GROUP BY st,pd ";
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,pd FROM $xtable GROUP BY pd ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE pd=$1 GROUP BY st ORDER BY st LIMIT 2000";    
	$axisy=x("Packets");
	break;
    case "flows":
        $caption=x("Flows statistics for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st FROM $table WHERE $where";
	$pquery="";    
	$tquery="";
	$query="SELECT SQL_BIG_RESULT st,count(*)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";    
	$axisy=x("Flows");
	break;
    case "sipb":
        $caption=x("Top source hosts per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sip,bytes FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sip FROM $xtable GROUP BY sip ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sip=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "sipp":
        $caption=x("Top source hosts per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sip,pck FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sip FROM $xtable GROUP BY sip ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sip=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "sdis":
        $caption=x("Top source hosts distribution for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sip,dip FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT count(distinct st,dip)as c,sip FROM $xtable GROUP BY sip ORDER BY c DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,count(distinct dip)as c FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,count(distinct dip)as c FROM $xtable WHERE sip=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Distribution");
        break;
    case "dipb":
        $caption=x("Top destination hosts per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,dip,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,dip FROM $xtable GROUP BY dip ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE dip=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "dipp":
        $caption=x("Top destination hosts per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,dip,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,dip FROM $xtable GROUP BY dip ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE dip=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "ddis":
        $caption=x("Top destination hosts distribution for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sip,dip FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT count(distinct st,sip)as c,dip FROM $xtable GROUP BY dip ORDER BY c DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,count(distinct sip)as c FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,count(distinct sip)as c FROM $xtable WHERE dip=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Distribution");
        break;
    case "conb":
        $caption=x("Top hosts conversations per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sip,dip,bytes FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sip,dip FROM $xtable GROUP BY sip,dip ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sip=$1 and dip=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "conp":
        $caption=x("Top hosts conversations per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sip,dip,pck FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sip,dip FROM $xtable GROUP BY sip,dip ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sip=$1 and dip=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "appb": 
        $caption=x("Top applications per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,app,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,app FROM $xtable GROUP BY app ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE app=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "appp": 
        $caption=x("Top applications per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,app,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,app FROM $xtable GROUP BY app ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE app=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "protob":
        $caption=x("Top protocols per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,proto FROM $xtable GROUP BY proto ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE proto=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "protop": 
        $caption=x("Top protocols per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,proto FROM $xtable GROUP BY proto ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE proto=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "tosb":
        $caption=x("Top ToS/DSCP per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,tos,bytes FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,tos FROM $xtable GROUP BY tos ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE tos=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "tosp":
        $caption=x("Top ToS/DSCP per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,tos,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,tos FROM $xtable GROUP BY tos ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE tos=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "spb": 
        $caption=x("Top source ports per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,sp,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sp,proto FROM $xtable WHERE proto=6 OR proto=17 GROUP BY proto,sp ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE proto=$2 AND sp=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "spp": 
        $caption=x("Top source ports per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,sp,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sp,proto FROM $xtable WHERE proto=6 OR proto=17 GROUP BY proto,sp ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE proto=$2 AND sp=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "dpb": 
        $caption=x("Top destination ports per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,dp,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,dp,proto FROM $xtable WHERE proto=6 OR proto=17 GROUP BY proto,dp ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE proto=$2 AND dp=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "dpp": 
        $caption=x("Top destination ports per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,dp,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,dp,proto FROM $xtable WHERE proto=6 OR proto=17 GROUP BY proto,dp ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE proto=$2 AND dp=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "sifb": 
        $caption=x("Top source interfaces per byte for collector %s",$name);
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	if (strstr($fields,"rt")) {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,rt,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sif,rt FROM $xtable GROUP BY sif,rt ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sif=$1 AND rt=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	else {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sif FROM $xtable GROUP BY sif ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sif=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	$axisy=x("Bytes");
        break;
    case "sifp": 
        $caption=x("Top source interfaces per packet for collector %s",$name);
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	if (strstr($fields,"rt")) {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,rt,pck FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sif,rt FROM $xtable GROUP BY sif,rt ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sif=$1 AND rt=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	else {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,pck FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sif FROM $xtable GROUP BY sif ORDER BY p DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sif=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	$axisy=x("Packets");
        break;
    case "difb": 
        $caption=x("Top destination interfaces per byte for collector %s",$name);
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	if (strstr($fields,"rt")) {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,dif,rt,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,dif,rt FROM $xtable GROUP BY dif,rt ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE dif=$1 AND rt=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	else {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,dif,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,dif FROM $xtable GROUP BY dif ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE dif=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	$axisy=x("Bytes");
        break;
    case "difp": 
        $caption=x("Top destination interfaces per packet for collector %s",$name);
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	if (strstr($fields,"rt")) {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,dif,rt,pck FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(pck)as p,dif,rt FROM $xtable GROUP BY dif,rt ORDER BY p DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE dif=$1 AND rt=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	else {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,dif,pck FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(pck)as p,dif FROM $xtable GROUP BY dif ORDER BY p DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE dif=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	$axisy=x("Packets");
        break;
    case "cifb":
        $caption=x("Top interface conversations per byte for collector %s",$name);
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	if (strstr($fields,"rt")) {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,dif,rt,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sif,dif,rt FROM $xtable GROUP BY sif,dif,rt ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sif=$1 AND dif=$2 AND rt=$3 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	else {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,dif,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sif,dif FROM $xtable GROUP BY sif,dif ORDER BY b DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sif='$1' AND dif='$2' GROUP BY st ORDER BY st LIMIT 2000";	
	}
	$axisy=x("Bytes");
        break;
    case "cifp":
        $caption=x("Top interface conversations per packet for collector %s",$name);
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	if (strstr($fields,"rt")) {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,dif,rt,pck FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sif,dif,rt FROM $xtable GROUP BY sif,dif,rt ORDER BY p DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sif=$1 AND dif=$2 AND rt=$3 GROUP BY st ORDER BY st LIMIT 2000";	
	}
	else {
          $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sif,dif,bytes FROM $table WHERE $where";    
	  $pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sif,dif FROM $xtable GROUP BY sif,dif ORDER BY p DESC LIMIT $offset,10";
	  $query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sif='$1' AND dif='$2' GROUP BY st ORDER BY st LIMIT 2000";	
	}
	$axisy=x("Packets");
        break;


    case "sasb": 
        $caption=x("Top source ASes per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sas,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sas FROM $xtable GROUP BY sas ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sas=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "sasp": 
        $caption=x("Top source ASes per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sas,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sas FROM $xtable GROUP BY sas ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sas=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "dasb": 
        $caption=x("Top destination ASes per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,das,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,das FROM $xtable GROUP BY das ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE das=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "dasp": 
        $caption=x("Top destination ASes per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,das,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,das FROM $xtable GROUP BY das ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE das=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "casb": 
        $caption=x("Top AS conversations per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sas,das,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,sas,das FROM $xtable GROUP BY sas,das ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE sas=$1 AND das=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "casp": 
        $caption=x("Top AS conversations per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,sas,das,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,sas,das FROM $xtable GROUP BY sas,das ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE sas=$1 AND das=$2 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "nhb":
        $caption=x("Top next hops per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,nh,bytes FROM $table WHERE $where";
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,nh FROM $xtable GROUP BY nh ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE nh=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
        break;
    case "nhp":
        $caption=x("Top next hops per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,nh,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,nh FROM $xtable GROUP BY nh ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE nh=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
        break;
    case "icmpb":
        $caption=x("Top ICMP messages per byte for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,dp,bytes FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(bytes)as b,dp FROM $xtable WHERE proto=1 GROUP BY dp ORDER BY b DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE proto=1 GROUP BY st ORDER BY st LIMIT 2000";	
	$query="SELECT SQL_BIG_RESULT st,sum(bytes)as b FROM $xtable WHERE proto=1 AND dp=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Bytes");
	break;
    case "icmpp":
        $caption=x("Top ICMP messages per packet for collector %s",$name);
        $wquery="CREATE TEMPORARY TABLE $xtable SELECT st,proto,dp,pck FROM $table WHERE $where";    
	$pquery="SELECT SQL_BIG_RESULT sum(pck)as p,dp FROM $xtable WHERE proto=1 GROUP BY dp ORDER BY p DESC LIMIT $offset,10";
	$tquery="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE proto=1 GROUP BY st ORDER BY st LIMIT 2000";		
	$query="SELECT SQL_BIG_RESULT st,sum(pck)as p FROM $xtable WHERE proto=1 AND dp=$1 GROUP BY st ORDER BY st LIMIT 2000";	
	$axisy=x("Packets");
	break;
  }

  if ($bps) {
    if ($axisy==x("Bytes")) {
      $axisy=x("Bits per second");
      $caption=preg_replace("#bytes#","bps",$caption);
      $caption=preg_replace("#byte#","bps",$caption);
    }
    else
      $bps=0; /* disable bps (it is not bytes statistic) */
  }
}





function trends_maketemp() {
  global $where,$table,$xtable,$stat;

  if ($where) {
    $xtable="tm_$stat_$table";
    SQL_query("DROP TABLE IF EXISTS $xtable");
  }
  else
    $xtable=$table;
}


function trends_droptemp() {
  global $table,$xtable;
  if ($xtable!=$table) 
    SQL_query("DROP TABLE IF EXISTS $xtable");
}







function trends_matrix($wquery,$pquery,$tquery,$query,&$matrix,&$rows,&$item,&$items,&$totalbytes,$cnv2bps) {
  global $drp,$where;


  $items=0;    
  $item=array();
  $rows=0;
  $matrix=array();
  $totalbytes=array();

  if ($where && $wquery && !SQL_query($wquery)) {
    error_set(x("Query failed [phase1]. Check if table still exists or contact administrator."));
    return 1;
  }

  /* get most used sip,dip,sp,dp,.... */
  if ($pquery) { 
    $res=SQL_query($pquery);
    if ($res) {
      while ($row=SQL_fetch_array($res)) {
        $item[$items]=array($row[1],$row[2],$row[3]);
        $items++;
      }
      SQL_free_result($res);
    }
    else {
      error_set(x("Query failed [phase2]. Check if table still exists or contact administrator."));
      return 2;
    }
    
    if ($drp&&$tquery) {
      $res=SQL_query($tquery);
      if ($res) {
        while ($row=SQL_fetch_array($res))
	  if ($cnv2bps)
	    $totalbytes[$row[0]]=floor($row[1]*$cnv2bps);
	  else
	    $totalbytes[$row[0]]=$row[1];
        SQL_free_result($res);
      }
    }
  }
  else
    $items=1;

  for ($i=0;$i<$items;$i++) {
    $q = $query;
    if (isset($item[$i][0])) {
      $q=str_replace("$1",$item[$i][0],$q);
      if (isset($item[$i][1])) {
        $q=str_replace("$2",$item[$i][1],$q);
	if (isset($item[$i][2]))
          $q=str_replace("$3",$item[$i][2],$q);
      }
    }
    $res=SQL_query($q);
    if ($res) {
      while ($row=SQL_fetch_array($res)) {
	if ($cnv2bps)
          $matrix[$i][$row[0]]=floor($row[1]*$cnv2bps);
	else
          $matrix[$i][$row[0]]=$row[1];
	$rows++;
      }
      SQL_free_result($res);
    }
    else {
      error_set(x("Query failed [phase3]. Check if table still exists or contact administrator."));
      return 3;
    }
  }
/* PATCH for source/destination host distribution, etc. fix for <0 residual part */
  if (is_array($totalbytes)) {
    while (list($key,$val) = each($totalbytes)) {
      $sumay=0;
      for ($i=0;$i<$items;$i++)
  	$sumay+=$matrix[$i][$key];
      if ($sumay>$val)
	$totalbytes[$key]=$sumay;
    }
  }
  return 0;
}






function get_stat_format($stype,$table_desc,$step,&$statname,&$timeformat) {
  switch ($stype) {
    case 'h':
    case 'o':
      $statname=str_replace('*','',$table_desc);
      $statname=str_replace(' - ',': ',$statname);
      $statname.=" ".x("step=").($step/60).x("min");      
      $timeformat="%b %d %Y %X";
      break;
    case 'd':
    case 'p':
      $statname=str_replace('*','',$table_desc);
      $statname=str_replace('-',':',$statname);
      $statname.=" ".x("step=").($step/60).x("min");      
      $timeformat="%b %d %Y %X";
      break;
    case 'w':
    case 'q':
      $statname=str_replace('*','',$table_desc);
      $statname=str_replace('-',':',$statname);
      $statname.=" ".x("step=").($step/3600).x("hours");
      $timeformat="%a %b %d %Y";
      break;
    case 'm':
    case 'r':
      $statname=str_replace('*','',$table_desc);
      $statname=str_replace('-',':',$statname);
      $statname.=" ".x("step=").($step/3600).x("hours");
      $timeformat="%b %d %Y";
      break;
    default:
      error_set(x("Unknown table..."));
      return 100;
  }  
  return 0;
}


function get_table_select($type="") {
  global $id_c,$id_t,$list_coll,$list_tables,$table,$fields;

  if (!is_array($list_coll) || count($list_coll)==0)
    MsgFatal(x("No collector is defined... Use Options->Collectors menu first."));
  if ($id_c && $list_coll[$id_c])
    $list_tables=load_tables($id_c,$type);
  else {
    list($id_c,$coll_name)=each($list_coll);
    $list_tables=load_tables($id_c,$type);  
  }


  if ($id_t && $list_tables[$id_t])
    $table=$id_t;
  else {
    if (is_array($list_tables) && count($list_tables)) {
      reset($list_tables);
      list($id_t,$table_name)=each($list_tables);
      $table=$id_t;
    }
    else
      $table="";
  }

  $fields="";
  if ($table)
    $fields=GetTableFields($table);

  if (!is_array($list_tables) || count($list_tables)==0)
    MsgWarn(x("No tables found for selected collector."));
}


function show_table_selector() {
  global $id_c,$id_t,$list_coll,$list_tables,$u_java;
  
  echo "<TR><TD COLSPAN=\"2\">\n";
    WinStart(x("Table selector"));
    TItem(x("Collector:"));
    TItem(InputSelect("id_c",select_list($list_coll,$id_c),($u_java)?"onchange=\"this.form.submit();\"":""));
    TItem(x("Table:"));
    TItem(InputSelect("id_t",select_list($list_tables,$id_t),($u_java)?"onchange=\"this.form.submit();\"":""));
    TItem(InputSubmit("select",x("Select")));
    WinEnd();
  echo "</TD></TR>\n";
}



function restriction_cond($where,$coll,$fields,$networks) {
  global $u_id_grp,$u_rights;

  if (strstr($u_rights,"admin"))
    return $where;
 
  $allow=array();
  $match=0;

  $v=SQL_escape($u_id_grp);
  $res=SQL_query("SELECT id_coll,type,cond FROM x_group_res WHERE id_group='$v'");
  if ($res) {
    $i=0;
    while ($row=SQL_fetch_array($res)) {
      $allow[$i][0]=$row[0];
      $allow[$i][1]=$row[1];
      $allow[$i][2]=$row[2];
      $i++;
    }
    SQL_free_result($res);
  }

  if (count($allow)) {
    foreach ($allow as $rule) {
      if (($rule[0] == $coll) || ($rule[0]==0)) {
	switch ($rule[1]) {
	  case 'ip':
	    $ip1="";
	    $ip2="";
	    parse_ip($ip1,"sip",$rule[2],0,$networks);
	    parse_ip($ip2,"dip",$rule[2],0,$networks);
	    if (strstr($fields,"sip") && strstr($fields,"dip"))
	      where_add($where,'',"(($ip1)OR($ip2))",'','AND');
	    elseif (strstr($fields,"sip"))
	      where_add($where,'',"($ip1)",'','AND');
	    elseif (strstr($fields,"dip"))
	      where_add($where,'',"($ip2)",'','AND');
	    break;
	  case 'if':
	    $if1="";
	    $if2="";
	    parse_iface($if1,"sif",$rule[2],0);
	    parse_iface($if2,"dif",$rule[2],0);
	    if (strstr($fields,"sif") && strstr($fields,"dif"))
	      where_add($where,'',"(($if1)OR($if2))",'','AND');
	    elseif (strstr($fields,"sif"))
	      where_add($where,'',"($if1)",'','AND');
	    elseif (strstr($fields,"dif"))
	      where_add($where,'',"($if2)",'','AND');
	    break;
	  case 'as':
	    $as1="";
	    $as2="";
	    parse_num($as1,"sas",$rule[2],0,0,65535);
	    parse_num($as2,"das",$rule[2],0,0,65535);
	    if (strstr($fields,"sas") && strstr($fields,"das"))
	      where_add($where,'',"(($as1)OR($as2))",'','AND');
	    elseif (strstr($fields,"sas"))
	      where_add($where,'',"($as1)",'','AND');
	    elseif (strstr($fields,"das"))
	      where_add($where,'',"($as2)",'','AND');
	    break;
	}
	$match=1;
      }

    }
    if ($match==0)
      where_add($where,''," 0 ",'','AND'); /* don't show anything DENY access */
  }
  return $where;
}

function change_fields($src,$dst) {
  $nsrc="n".$src;
  $ndst="n".$dst;
  
  global $$src,$$dst,$$nsrc,$$ndst;
  
  $a=$$dst;
  $$dst=$$src;
  $$src=$a;

  $b=$$ndst;
  $$ndst=$$nsrc;
  $$nsrc=$b;
}

/* fix for time that is not aligned to step, usually caused by switching betwwen summer and winter time*/
function fixup_matrix(&$matrix,$minst,$step,$items) {
  $fixed=array();
  for ($i=0;$i<$items;$i++) {
    if (isset($matrix[$i])) {
      foreach ($matrix[$i] as $j=>$val) {
        if (($j-$minst) % $step != 0)
          $j=(round(($j-$minst) / $step) * $step)+$minst;	
        $fixed[$i][$j]=$val;
      }
    }
  }
  $matrix=$fixed;
}

function fixup_array(&$matrix,$minst,$step) {
  $fixed=array();
  foreach ($matrix as $j=>$val) {
    if (($j-$minst) % $step != 0)
      $j=(round(($j-$minst) / $step) * $step)+$minst;	
    $fixed[$j]=$val;
  }
  $matrix=$fixed;
}

function get_ifacelist($table,$where,$fields) {
  $list=array();
  
  $query="SELECT distinct sif";
  if (strstr($fields,"rt")!==false)
    $query.=",rt";
  $query.=" FROM ".SQL_escape($table);
  if ($where)
    $query.=" WHERE ".$where;
  $res=SQL_query($query);
  if ($res) {
    while ($row=SQL_fetch_array($res))
      $list[]=$row;
    SQL_free_result($res);
  }
  return $list;
}

?>