<?php
define('HELPMARK','user_data.html#data_trends');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once('slib.php');

getGlobalVar('table',$table);
getGlobalVar('stat',$stat);
getGlobalVar('id_c',$id_c);
getGlobalVar('id_t',$id_t);

PageHead();
PageLogo();
MenuStart('data','');
PageTitle(x("Trends - Select action"),'i_trend.gif');

$list_coll=restriction_colllist(list_table("x_coll","ORDER BY name"));
get_table_select();

if (!$table)
  MsgFatal(x("Table not selected."));
$fields=GetTableFields($table);
if (!$fields)
  MsgFatal(x("Table not found."));
$stat_list=trends_stat_list($fields);


$list_act=array();
switch ($stat) {
  case "sipb":
    add_infoip("sip");
    check_trends_list(array("dipb","appb","spb","dpb"));
  break;
  case "sipp":
    add_infoip("sip");
    check_trends_list(array("dipp","appp","spp","dpp"));
  break;
  case "sdis":
    add_infoip("sip");
    check_trends_list(array("dipb","appb","spb","dpb"));
  break;
  case "dipb":
    add_infoip("dip");
    check_trends_list(array("sipb","appb","spb","dpb"));
  break;
  case "dipp":
    add_infoip("dip");
    check_trends_list(array("sipp","appp","spp","dpp"));
  break;
  case "ddis":
    add_infoip("dip");
    check_trends_list(array("sipb","appb","spb","dpb"));
  break;

  case "conb":
    add_infoip("sip");
    add_infoip("dip");
    check_trends_list(array("appb","protob","spb","dpb"));
  break;
  case "conp":
    add_infoip("sip");
    add_infoip("dip");
    check_trends_list(array("appp","protop","spp","dpp"));
  break;
  case "appb":
    add_infoport("app");
    check_trends_list(array("sipb","dipb","spb","dpb"));
  break;
  case "appp":
    add_infoport("app");
    check_trends_list(array("sipp","dipp","spp","dpp"));
  break;
  case "protob":
    check_trends_list(array("sipb","dipb","appb","spb","dpb"));
  break;
  case "protop":
    check_trends_list(array("sipp","dipp","appp","spp","dpp"));
  break;
  case "tosb":
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "tosp":
    check_trends_list(array("sipp","dipp","appp"));
  break;

  case "spb":
    add_infoport("sp");
    check_trends_list(array("sipb","dipb"));
  break;
  case "spp":
    add_infoport("sp");
    check_trends_list(array("sipp","dipp"));
  break;
  case "dpb":
    add_infoport("dp");
    check_trends_list(array("sipb","dipb"));
  break;
  case "dpp":
    add_infoport("dp");
    check_trends_list(array("sipp","dipp"));
  break;


  case "sifb":
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "sifp":
    check_trends_list(array("sipp","dipp","appp"));
  break;
  case "difb":
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "difp":
    check_trends_list(array("sipp","dipp","appp"));
  break;
  case "cifb":
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "cifp":
    check_trends_list(array("sipp","dipp","appp"));

  case "sasb":
    add_infoas("sas");
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "sasp":
    add_infoas("sas");
    check_trends_list(array("sipp","dipp","appp"));
  break;
  case "dasb":
    add_infoas("das");
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "dasp":
    add_infoas("das");
    check_trends_list(array("sipp","dipp","appp"));
  break;
  case "casb":
    add_infoas("sas");
    add_infoas("das");
    check_trends_list(array("sipb","dipb","appb"));
  break;
  case "casp":
    add_infoas("sas");
    add_infoas("das");
    check_trends_list(array("sipp","dipp","appp"));

  case "nhb":
  case "nhp":
    add_infoip("nh");
    check_trends_list();
  break;

  default:
    check_trends_list();
}


$list_act[]=array(x("Use the Data-&gt;Search menu"),PRG_PATH."src/data/search.php?".args("search="),1); 
$list_act[]=array(x("Use the Data-&gt;Interfaces menu"),PRG_PATH."src/data/iface.php?".args("search="),1); 
$list_act[]=array(x("Redefine Data-&gt;Trends searching condition"),PRG_PATH."src/data/trends.php?".args("search="),1); 

show_search_criteria();

$lastprio=0;
echo "<ol>\n";
foreach ($list_act as $act) {
  if ($lastprio!=$act[2]) {
    $lastprio=$act[2];
    echo "<br/><br/>";
  }
  if ($act[2])
    echo "<li>".ShowLink('<b>'.$act[0].'</b>',$act[1])."</li>\n";
  else
    echo "<li>".ShowLink($act[0],$act[1])."</li>\n";
}
echo "</ol>\n";



MenuEnd();
PageTail();


/* F U N C T I O N S */

function show_search_criteria() {
  $ret=array();
  $ret[]=add_search_criteria('st',x("Time:"));
  $ret[]=add_search_criteria('bytes',x("Bytes:"));
  $ret[]=add_search_criteria('pck',x("Packets:"));
  $ret[]=add_search_criteria('tos',x("Type of service:"));
  $ret[]=add_search_criteria('sip',x("Source IP address:"));
  $ret[]=add_search_criteria('dip',x("Destination IP address:"));
  $ret[]=add_search_criteria('sipl',x("Source network:"));
  $ret[]=add_search_criteria('dipl',x("Destination network:"));
  $ret[]=add_search_criteria('proto',x("Protocol:"));
  $ret[]=add_search_criteria('app',x("Application:"));
  $ret[]=add_search_criteria('sp',x("Source port:"));
  $ret[]=add_search_criteria('dp',x("Destination port:"));
  $ret[]=add_search_criteria('sif',x("Source interface:"));
  $ret[]=add_search_criteria('dif',x("Destination interface:"));
  $ret[]=add_search_criteria('sas',x("Source autonomous system:"));
  $ret[]=add_search_criteria('das',x("Destination autonomous system:"));
  $ret[]=add_search_criteria('flg',x("TCP flags:"));
  $ret[]=add_search_criteria('rt',x("Export device IP address:"));
  $ret[]=add_search_criteria('nh',x("Next-hop IP address:"));

  while (list($key,$val)=each($ret)) {
    if (!is_array($ret[$key]))
      unset($ret[$key]);
  }

  if (count($ret)) {
    $i=0;
    WinStart(x("Searching criteria"));
    reset($ret);
    foreach ($ret as $r) {
      if ($i)
        TNext();
      TItem($r[0]);
      TItem($r[1]);
      $i++;
    }
    WinEnd();
    echo "<br/>\n";
  }
}

function add_search_criteria($name,$text) {
  $ret="";
  $nname="n".$name;
  getGlobalVar($name,$tmp1);
  getGlobalVar($$name,$tmp2);

  if (strlen(trim($tmp1))) {
    if ($tmp2)
      $ret=array($text,x("not")." ".$tmp1);
    else
      $ret=array($text,$tmp1);
  }
  return $ret;
}



function add_infoip($field) {
  global $list_act;
  getGlobalVar($field,$ip);
  if (is_numeric($ip))
    $ip=num2ip($ip);
  $list_act[]=array(x("Get information about IP address: ").$ip,PRG_PATH."src/data/info_ip.php?host=$ip&check=1",2); 
}

function add_infoas($field) {
  global $list_act;
  getGlobalVar($field,$as);
  $list_act[]=array(x("Get information about autonomous system (AS): ").$as,PRG_PATH."src/data/info_as.php?as=$as&command=1",2); 
}


function add_infoport($field) {
  global $list_act;
  getGlobalVar($field,$port);
  if ($port>=100000 && $port<=165535)
    $port-=100000;
  if ($port<=65535)
    $list_act[]=array(x("Get information about TCP/UDP port: ").$port,PRG_PATH."src/help/ports.php?port=$port",2);
}




function check_trends_list($prefer) {
  global $stat_list,$list_act,$stat;

  $prefs=array();
  if (is_array($prefer)) {
    foreach ($prefer as $pref) {
      if (isset($xxx)) unset($xxx);
      getGlobalVar(getwolast($pref),$xxx);
      if (isset($stat_list[$pref]) && (strlen($xxx)==0 || strstr($xxx,',') || (strstr($xxx,'-')&&!strstr($xxx,'.')))) {
	$prefs[$pref]=1;
        $list_act[]=array($stat_list[$pref],PRG_PATH."src/data/trends.php?".args("stat=$pref"),1);
      } 
    }
  }

  reset($stat_list);
  switch (getlast($stat)) {
    case 'b':
      while (list($key,$val)=each($stat_list)) {
	if ((getlast($key)=='b' || $key=="bytes") && !isset($prefs[$key]))
          $list_act[]=array($stat_list[$key],PRG_PATH."src/data/trends.php?".args("stat=$key"),0);
      }
      break;
    case 'p':
      while (list($key,$val)=each($stat_list)) {
	if ((getlast($key)=='p' || $key=="pck") && !isset($prefs[$key]))
          $list_act[]=array($stat_list[$key],PRG_PATH."src/data/trends.php?".args("stat=$key"),0);
      }
      break;
    default:
      while (list($key,$val)=each($stat_list)) {
	if (!isset($prefs[$key]))
          $list_act[]=array($stat_list[$key],PRG_PATH."src/data/trends.php?".args("stat=$key"),0);
      }
      break;
  }
}


function getlast($str) {
  return substr($str,-1,1);
}

function getwolast($str) {
  return substr($str,0,-1);
}

?>