<?php
define('HELPMARK','user_exports.html#user_exports_el');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);

PageHead();
PageLogo();
MenuStart('exports');
PageTitle(x("Export list"),'i_export.gif');
RequireRights("export");

if ($subdelete)
  $command="delete";


check_command('delete','deletesubmit');


if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	if (preg_match("#export[a-z]+_".$u_id.".*\.csv$#i",$id)||CheckRights('admin')) {
	  if (!unlink(PRG_EXPORTDIR.$id)) {
	    $error=1;
	    MsgError(x("Can't unlink export file %s."),$id);
	  }
	}
	else {
	  $error=1;
	  MsgError(x("Can't delete export %s. You have access to this export"),$id);
	}
      }
    }
    if (!$error)
      MsgInfo(x("Selected exports were deleted ...")); 
  }
  $command="";
}


if ($command=="delete") {
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected exports?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}



if ($command=="") {
  $freespace=disk_free_space(PRG_EXPORTDIR);
  MsgInfo(x("Current free space for exports is: ").number2human($freespace,"",2));
  if ($freespace < 1000000000)
    MsgWarn(x("Free space is bellow 1GB! Delete some data and/or clear system."));

  $handle=opendir(PRG_EXPORTDIR);
  if ($handle) {
    $i=0;
    if (CheckRights('admin')) {
      while ($file = readdir($handle)) {
        if (is_file(PRG_EXPORTDIR.$file) && (
	    preg_match("#export[a-z]+_[0-9]+.*\.csv$#i",$file) ||
	    preg_match("#exporttable.*\.gz$#i",$file)
	     )) {
          if ($i==0) {
	    FormStart();
	    JSInvert();
            WinTStart();
            THItem(ShowInvert());
	    THItem(x("Filename"));
	    THItem(x("Size"));
	    THItem(x("Data created"));
	  }
          TLine();
	  TItem(InputCheck("c__$i",$file));
          TItem(ShowLink($file,"download.php?id=$file"));
	  TItem(filesize(PRG_EXPORTDIR.$file),'ALIGN="right"');
	  TItem(strftime('%x %X',filectime(PRG_EXPORTDIR.$file)),'ALIGN="right"');
	  $i++;
        }
      }
    }
    else {
      while ($file = readdir($handle)) {
        if (is_file(PRG_EXPORTDIR.$file) && (preg_match("#export[a-z]+_".$u_id."_.*\.csv$#i",$file))) {
          if ($i==0) {
	    FormStart();
	    JSInvert();
            WinTStart();
            THItem(ShowInvert());
	    THItem(x("Filename"));
	    THItem(x("Size"));
	    THItem(x("Create date"));
	  }
          TLine();
	  TItem(InputCheck("c__$i",$file));
          TItem(ShowLink($file,"download.php?id=$file"));
	  TItem(filesize(PRG_EXPORTDIR.$file),'ALIGN="right"');
	  TItem(strftime('%x %X',filectime(PRG_EXPORTDIR.$file)),'ALIGN="right"');
	  $i++;
        }
      }    
    }
    if ($i) {
      TNext();
      TItem("<br>".InputSubmit("subdelete",x("Delete")),'ALIGN="center" COLSPAN="4"');
      WinEnd();
      echo InputHidden("c__num",$i);      
      FormEnd();
    }
    else
      MsgInfo(x("No exports found... You must search&export data before"));  
    closedir($handle);
    
  }
  else
    MsgError(x("Can't read content of export directory:")."<br>".PRG_EXPORTDIR);
}

MenuEnd();
PageTail();

?>